'
' Record a wave file using microphone and save file to disk.
'
VERSION "0.0001"
CONSOLE

	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
	IMPORT "xio"				' Console input/ouput LIBRARY
	IMPORT "winmm"

DECLARE FUNCTION Entry ()
DECLARE FUNCTION WaveRecordStart (channels, resolution, rate)
DECLARE FUNCTION WaveRecordStop (file$)


FUNCTION Entry ()

	WaveRecordStart (2, 16, 22050)
	
	? "Talk for 5 seconds."
	XstSleep (5000)
	? "Finished recording."
	
	fn$ = "wavetest.wav"
	WaveRecordStop (fn$)

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

FUNCTION WaveRecordStart (channels, resolution, rate)

' channels: 1 = mono, 2 = stereo
' resolution/Bits Per Sample: 16 or 8
'
' rate/samples per second (higher quality = bigger wav...)
' 11025 speech quality
' 22050 radio quality
' 44100 CD music quality

' *Always* close all/flush 1st...
	mciSendStringA (&"close all", NULL, 0, 0)

' Open a new wav device
	mciSendStringA (&"open new Type waveaudio Alias capture", NULL, 0, 0)

' Always start at the beginning
	mciSendStringA (&"seek capture to start", NULL, 0, 0)

' Format the recording
	alignment = channels * resolution / 8.0
	cmd$ = 	"set capture alignment " + STRING$(alignment) _
					+ " bitspersample " + STRING$(resolution) + " samplespersec " _
					+ STRING$(rate) + " channels " + STRING$(channels) + " bytespersec " _
					+ STRING$(alignment * rate)
	mciSendStringA (&cmd$, NULL, 0, 0)
	mciSendStringA (&"record capture", NULL, 0, 0)
END FUNCTION

FUNCTION WaveRecordStop (file$)

	cmd$ = "save capture " + file$ 				' note: should use short filename or filename without spaces
	mciSendStringA (&cmd$, NULL, 0, 0) 
	mciSendStringA (&"stop capture wait", NULL, 0, 0)
	mciSendStringA (&"close capture", NULL, 0, 0)
END FUNCTION

END PROGRAM